//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers  2
#property indicator_color1   LimeGreen
#property indicator_color2   Orange
#property indicator_width1   2
#property indicator_width2   2
#property indicator_maximum  1
#property indicator_minimum -1

//
//
//
//
//

extern string TimeFrame = "Current time frame";
extern int    Length = 34;
extern int    Price  = PRICE_CLOSE;

double LRSBufferU[];
double LRSBufferD[];
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,LRSBufferU); SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"LR up");
   SetIndexBuffer(1,LRSBufferD); SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,"LR down");
      timeFrame         = stringToTimeFrame(TimeFrame);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame == "returnBars"; if (returnBars) return(0);
      timeFrame = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" LR slope histo");
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { LRSBufferU[0] = limit+1; return(0); }
         if (timeFrame!=Period())
         {
            limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
            for (int i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,timeFrame,Time[i]);               
                  LRSBufferU[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Price,0,y);
                  LRSBufferD[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Length,Price,1,y);
            }
            return(0);                  
         }

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      double slope  = LinearRegressionSlope(Length,i);
      LRSBufferU[i] = EMPTY_VALUE;
      LRSBufferD[i] = EMPTY_VALUE;
         if (slope > 0) LRSBufferU[i] =  1;
         if (slope < 0) LRSBufferD[i] = -1;
   }
   return(0);
}

//---------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------
//
//
//
//
//

int    lrsperiod=EMPTY_VALUE;
double lrssumX;
double lrssumXSqr;
double lrsdivisor;
double LinearRegressionSlope(int len,int shift)
{
   double LinearRegSlope;
   double SumXY = 0;
   double SumY  = 0;

   //
   //
   //
   //
   //

   if (lrsperiod != len)
   {
      lrsperiod  = len;
      lrssumX    = lrsperiod * (lrsperiod-1) / 2;
      lrssumXSqr = lrsperiod * (lrsperiod-1) * (2 * lrsperiod - 1) / 6;
      lrsdivisor = MathPow(lrssumX,2) - lrsperiod * lrssumXSqr;
   }

   //
   //
   //
   //
   //

   for (int i=0; i<lrsperiod; i++)
   {
      double price = iMA(NULL,0,1,0,MODE_EMA,Price,i+shift);
            SumXY += i*price;
            SumY  +=   price;
   }
   if( lrsdivisor != 0 ) 
         	LinearRegSlope = (lrsperiod * SumXY - lrssumX * SumY)/lrsdivisor;
   else     LinearRegSlope = 0; 
   return  (LinearRegSlope);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}